VirtualBox

source: vbox/trunk/configure@ 3028

Last change on this file since 3028 was 3028, checked in by vboxsync, 17 years ago

use -lpthread together with -lxalan and -lxerces

  • Property svn:executable set to *
File size: 30.2 KB
Line 
1#!/bin/bash
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 innotek GmbH
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16# If you received this file as part of a commercial VirtualBox
17# distribution, then only the terms of your commercial VirtualBox
18# license agreement apply instead of the previous paragraph.
19#
20
21LC_ALL=C
22export LC_ALL
23
24#
25# Defaults
26#
27OSE=1
28WITH_XPCOM=1
29WITH_LIBIDL=1
30WITH_QT=1
31WITH_SDL_TTF=1
32WITH_HAL=1
33CC="gcc"
34CXX="g++"
35BCC="bcc"
36YASM="yasm"
37IASL="iasl"
38AS86="as86"
39XSLTPROC="xsltproc"
40GENISOIMAGE="genisoimage"
41MKISOFS="mkisofs"
42INCXALAN=""
43LIBXALAN="-lxalan-c"
44INCXERCES=""
45LIBXERCES="-lxerces-c"
46INCSDL="/usr/include/SDL"
47LIBSDL="-lSDL"
48LIBSDLMAIN="-lSDLmain"
49LIBCRYPTO="-lcrypto"
50LIBPTHREAD="-lpthread"
51LIBX11="-L/usr/X11R6/lib -lXext -lX11"
52LIBXCURSOR="-lXcursor"
53INCZ=""
54LIBZ="-lz"
55INCPNG=""
56LIBPNG="-lpng"
57CFLAGSHAL="-I/usr/include/hal -I/usr/include/dbus-1.0 -I/usr/lib/dbus-1.0/include"
58LIBPATHHAL=""
59LIBHAL="-lhal -ldbus-1"
60QTDIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3 /usr/lib64/qt-3.3"
61KBUILDDIR="`cd $(dirname $0); pwd`/kBuild"
62DEVDIR="`cd $(dirname $0); pwd`/tools"
63if [ -d /lib/modules/`uname -r`/build ]; then
64 LINUX="/lib/modules/`uname -r`/build"
65else
66 LINUX="/usr/src/linux"
67fi
68KCHMVIEWER="kchmviewer"
69LOG="configure.log"
70CNF="AutoConfig.kmk"
71ENV="env.sh"
72BUILD_TYPE="release"
73# the restricting tool is ar (mri mode).
74INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
75
76if (cd $(dirname $0); pwd)|grep -q "$INVALID_CHARS"; then
77 echo "Error: VBox base path contains invalid characters!"
78 exit 1
79fi
80
81function cleanup()
82{
83 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
84}
85
86function fail()
87{
88 if [ -z "$nofatal" -o "x$1" != "x" ]; then
89 cleanup
90 rm -f $ENV
91 exit 1
92 fi
93}
94
95function log_success()
96{
97 if [ -n "$1" ]; then echo -n "$1, "; fi
98 echo "OK."
99 echo -e "$1\n\n" >> $LOG
100}
101
102function log_failure()
103{
104 echo -e "\n ** $1!"
105 echo -e "** $1!\n" >> $LOG
106}
107
108function cnf_append()
109{
110 printf "%-30s := %s\n" "$1" "$2" >> $CNF
111}
112
113# Wrapper for ancient /usr/bin/which on darwin that always returns 0
114function which_wrapper()
115{
116 if [ -z "$have_ancient_which" ]; then
117 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
118 have_ancient_which="yes"
119 else
120 have_ancient_which="no"
121 fi
122 fi
123 if [ "$have_ancient_which" = "yes" ]; then
124 local retval=`which $* 2>/dev/null`
125 echo "$retval"
126 test -n "$retval" -a -e "$retval"
127 else
128 which $* 2> /dev/null
129 fi
130}
131
132function check_avail()
133{
134 if [ -z "$1" ]; then
135 log_failure "$2 is empty"
136 fail $3
137 return 1
138 elif which_wrapper $1 > /dev/null; then
139 return 0
140 else
141 log_failure "$1 (variable $2) not found"
142 fail $3
143 return 1
144 fi
145}
146
147# Prepare a test
148function test_header()
149{
150 echo "***** Checking $1 *****" >> $LOG
151 echo -n "Checking for $1: "
152}
153
154# Compile a test
155function test_compile()
156{
157 echo "compiling the following source file:" >> $LOG
158 cat .tmp_src.cc >> $LOG
159 echo "using the following command line:" >> $LOG
160 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
161 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
162 if (($?!=0)); then
163 if [ -z "$4" ]; then
164 echo -e "\n $2 not found at $1 or $3 headers not found"
165 echo " Check the file $LOG for detailed error information."
166 fail
167 else
168 echo "not found."
169 echo -e "\n" >> $LOG
170 fi
171 return 1
172 fi
173 return 0
174}
175
176# Execute a compiled test binary
177function test_execute()
178{
179 echo "executing the binary" >> $LOG
180 ./.tmp_out > .test_execute.log
181 rc=$?
182 cat .test_execute.log | tee -a $LOG
183 if (($rc!=0)); then
184 fail $1
185 return 1
186 fi
187 echo -e "\n\n" >> $LOG
188 return 0
189}
190
191#
192# Check for OS, MACHINE, CPU
193#
194function check_environment()
195{
196 test_header environment
197 CPU=`uname -m`
198 case "$CPU" in
199 i[3456789]86|x86)
200 MACHINE='x86'
201 LIB='lib'
202 ;;
203 x86_64|amd64)
204 MACHINE='amd64'
205 CPU='k8'
206 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
207 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
208 LIB='lib64'
209 ;;
210 *)
211 log_failure "Cannot determine system"
212 exit 1
213 ;;
214 esac
215 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr 'A-Z' 'a-z'`
216 case "$OS" in
217 linux)
218 ;;
219 darwin)
220 ;;
221 *)
222 log_failure "Cannot determine OS"
223 exit 1
224 ;;
225 esac
226 DEVDIR_BIN="$DEVDIR/$OS.$MACHINE/bin"
227 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$MACHINE"
228 log_success "Determined $OS.$MACHINE"
229
230 # Automatically disable XPCOM on darwin.
231 if [ "$OS" = "darwin" -a $WITH_XPCOM -eq 1 ]; then
232 WITH_XPCOM=0
233 WITH_LIBIDL=0
234 WITH_QT=0
235 echo "Disabling checks for XPCOM related components."
236 fi
237}
238
239#
240# Check for gcc with version >= 3.2.
241# We depend on a working gcc, if we fail terminate in every case.
242#
243function check_gcc()
244{
245 test_header gcc
246 if check_avail "$CC" CC really; then
247 cc_ver=`$CC -dumpversion`
248 if check_avail "$CXX" CXX really; then
249 cxx_ver=`$CXX -dumpversion`
250 cc_maj=`echo $cc_ver|cut -d. -f1`
251 cc_min=`echo $cc_ver|cut -d. -f2`
252 if [ "x$cc_ver" != "x$cxx_ver" ]; then
253 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
254 fail really
255 elif (($cc_maj>3)); then
256 log_success "found version $cc_ver"
257 elif (($cc_maj<3 || $cc_min<2)); then
258 log_failure "gcc version $cc_ver found, expected at least gcc version 3.2"
259 fail really
260 else
261 log_success "found version $cc_ver"
262 fi
263 if [ "$CC" != "gcc" ]; then
264 cnf_append "TOOL_GCC3_CC" "$CC"
265 cnf_append "TOOL_GCC3_AS" "$CC"
266 cnf_append "TOOL_GXX3_CC" "$CC"
267 cnf_append "TOOL_GXX3_AS" "$CC"
268 fi
269 if [ "$CXX" != "g++" ]; then
270 cnf_append "TOOL_GCC3_CXX" "$CXX"
271 cnf_append "TOOL_GCC3_LD" "$CXX"
272 cnf_append "TOOL_GXX3_CXX" "$CXX"
273 cnf_append "TOOL_GXX3_LD" "$CXX"
274 fi
275 fi
276 fi
277}
278
279#
280# Check for the bcc compiler, needed for compiling the BIOS
281#
282function check_bcc()
283{
284 test_header bcc
285 if check_avail "$BCC" BCC; then
286 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
287 if (($?!=0)); then
288 log_failure "not found"
289 fail
290 else
291 echo "compiling the following source file:" >> $LOG
292 echo '
293int foo(a)
294 int a;
295{
296 return 0;
297}
298' > .tmp_src.c
299 cat .tmp_src.c >> $LOG
300 local bcc_path=`which_wrapper $BCC`
301 local bcc_dir="`dirname $bcc_path`/"
302 echo "using the following command line:" >> $LOG
303 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
304 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
305 if (($?!=0)); then
306 log_failure "not found"
307 fail
308 else
309 log_success "found version $bcc_ver"
310 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
311 fi
312 fi
313 fi
314}
315
316#
317# Check for the as86 assembler, needed for compiling the BIOS
318#
319function check_as86()
320{
321 test_header as86
322 if check_avail "$AS86" AS86; then
323 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
324 if (($?!=0)); then
325 log_failure "not found"
326 fail
327 else
328 log_success "found version $as86_ver"
329 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
330 fi
331 fi
332}
333
334#
335# Check for yasm, needed to compile assembler files
336#
337function check_yasm()
338{
339 test_header yasm
340 if check_avail "$YASM" YASM; then
341 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
342 if (($?!=0)); then
343 log_failure "not found"
344 fail
345 else
346 yasm_maj=`echo $yasm_ver|cut -d. -f1`
347 yasm_min=`echo $yasm_ver|cut -d. -f2`
348 yasm_rev=`echo $yasm_ver|cut -d. -f3`
349 yasm_ver_mul=$(($yasm_maj*10000+$yasm_min*100+$yasm_rev))
350 if (($yasm_ver_mul<501)); then
351 log_failure "found version $yasm_ver, expected at least 0.5.1"
352 fail
353 else
354 log_success "found version $yasm_ver"
355 fi
356 fi
357 fi
358}
359
360#
361# Check for the iasl ACPI compiler, needed to compile vbox.dsl
362#
363function check_iasl()
364{
365 test_header iasl
366 if check_avail "$IASL" IASL; then
367 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
368 if (($?!=0)); then
369 log_failure "not found"
370 fail
371 else
372 log_success "found version $iasl_ver"
373 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
374 fi
375 fi
376}
377
378#
379# Check for xsltproc, needed by Main
380#
381function check_xsltproc()
382{
383 test_header xslt
384 if check_avail "$XSLTPROC" XSLTPROC; then
385 xsltproc_ver=`$XSLTPROC --version`
386 if (($?!=0)); then
387 log_failure "not found"
388 fail
389 else
390 log_success "found"
391 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
392 fi
393 fi
394}
395
396#
397# Check for mkisofs, needed to build the CDROM image containing the additions
398#
399function check_mkisofs()
400{
401 test_header mkisofs
402 if which_wrapper $GENISOIMAGE > /dev/null; then
403 mkisofs_ver=`$GENISOIMAGE --version`
404 if (($?!=0)); then
405 log_failure "not found"
406 fail
407 else
408 log_success "found $mkisofs_ver"
409 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
410 fi
411 elif check_avail "$MKISOFS" MKISOFS; then
412 mkisofs_ver=`$MKISOFS --version`
413 if (($?!=0)); then
414 log_failure "not found"
415 fail
416 else
417 log_success "found $mkisofs_ver"
418 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
419 fi
420 fi
421}
422
423#
424# Check for xalan, needed by VBoxXML
425#
426function check_xalan()
427{
428 if [ -n "$LIBXALAN" ]; then
429 test_header xalan
430 echo '
431#include <cstdio>
432#include <xalanc/Include/XalanVersion.hpp>
433extern "C" int main(void)
434{
435 printf("found version %d.%d.%d",
436 XALAN_VERSION_MAJOR, XALAN_VERSION_MINOR, XALAN_VERSION_REVISION);
437#if _XALAN_VERSION >= 10800
438 printf(", OK.\n");
439 return 0;
440#else
441 printf(", expected version 1.8.0 or higher\n");
442 return 1;
443#endif
444}
445' > .tmp_src.cc
446 if test_compile "$LIBXALAN $LIBPTHREAD ${INCXALAN:+-I$INCXALAN}" xalan xalanc; then
447 if test_execute; then
448 cnf_append "SDK_VBOX_XALAN_LIBS" "`echo $LIBXALAN|sed 's+-l++g'`"
449 cnf_append "SDK_VBOX_XALAN_INCS" "$INCXALAN"
450 fi
451 fi
452 else
453 echo "Building xalan from shipped sources."
454 echo -e "Building xalan from shipped sources.\n\n" >> $LOG
455 fi
456}
457
458#
459# Check for xerces, needed by VBoxXML
460#
461function check_xerces()
462{
463 if [ -n "$LIBXERCES" ]; then
464 test_header xerces
465 echo '
466#include <cstdio>
467#include <xercesc/util/XercesVersion.hpp>
468extern "C" int main(void)
469{
470 printf("found version %d.%d.%d",
471 XERCES_VERSION_MAJOR, XERCES_VERSION_MINOR, XERCES_VERSION_REVISION);
472#if _XERCES_VERSION >= 20500
473 printf(", OK.\n");
474 return 0;
475#else
476 printf(", expected version 2.5.0 or higher");
477 return 1;
478#endif
479}
480' > .tmp_src.cc
481 if test_compile "$LIBXERCES $LIBPTHREAD ${INCXERCES:+-I$INCXERCES}" xerces xercesc; then
482 if test_execute; then
483 cnf_append "SDK_VBOX_XERCES_LIBS" "`echo $LIBXERCES|sed 's+-l++g'`"
484 cnf_append "SDK_VBOX_XERCES_INCS" "$INCXERCES"
485 fi
486 fi
487 else
488 echo "Building xerces from shipped sources."
489 echo -e "Building xerces from shipped sources.\n\n" >> $LOG
490 fi
491}
492
493#
494# Check for libIDL, needed by xpcom
495#
496check_libidl()
497{
498 test_header libIDL
499
500 if which_wrapper libIDL-config-2 > /dev/null; then
501 libidl_ver=`libIDL-config-2 --version`
502 if (($?!=0)); then
503 log_failure "not found"
504 fail
505 else
506 log_success "found version $libidl_ver"
507 cnf_append "VBOX_LIBIDL_CONFIG" \
508 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
509 fi
510 elif check_avail "libIDL-config" libIDL-config; then
511 libidl_ver=`libIDL-config --version`
512 if (($?!=0)); then
513 log_failure "not found"
514 fail
515 else
516 log_success "found version $libidl_ver"
517 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
518 fi
519 fi
520}
521
522#
523# Check for openssl, needed for RDP
524#
525function check_ssl()
526{
527 test_header ssl
528 echo '
529#include <cstdio>
530#include <openssl/opensslv.h>
531extern "C" int main(void)
532{
533 printf("found version %s", OPENSSL_VERSION_TEXT);
534#if OPENSSL_VERSION_NUMBER >= 0x0090700
535 printf(", OK.\n");
536 return 0;
537#else
538 printf(", expected version 0.9.7 or higher\n");
539 return 1;
540#endif
541}
542' > .tmp_src.cc
543 if test_compile $LIBCRYPTO libcrypto openssl; then
544 if test_execute nofatal; then
545 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
546 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`echo $LIBCRYPTO|sed 's+-l++g'`"
547 fi
548 fi
549}
550
551#
552# Check for pthread, needed by VBoxSVC, frontends, ...
553#
554function check_pthread()
555{
556 test_header pthread
557 echo '
558#include <cstdio>
559#include <pthread.h>
560extern "C" int main(void)
561{
562 pthread_mutex_t mutex;
563 if (pthread_mutex_init(&mutex, NULL)) {
564 printf("pthread_mutex_init() failed\n");
565 return 1;
566 }
567 if (pthread_mutex_lock(&mutex)) {
568 printf("pthread_mutex_lock() failed\n");
569 return 1;
570 }
571 if (pthread_mutex_unlock(&mutex)) {
572 printf("pthread_mutex_unlock() failed\n");
573 return 1;
574 }
575 printf("found, OK.\n");
576}
577' > .tmp_src.cc
578 if test_compile $LIBPTHREAD pthread pthread; then
579 if test_execute; then
580 cnf_append "LIB_PTHREAD" "`echo $LIBPTHREAD|sed 's+-l++g'`"
581 fi
582 fi
583}
584
585#
586# Check for zlib, needed by VBoxSVC, Runtime, ...
587#
588function check_z()
589{
590 test_header zlib
591 echo '
592#include <cstdio>
593#include <zlib.h>
594extern "C" int main(void)
595{
596 printf("found version %s", ZLIB_VERSION);
597#if ZLIB_VERNUM >= 0x1210
598 printf(", OK.\n");
599 return 0;
600#else
601 printf(", expected version 1.2.1 or higher\n");
602 return 1;
603#endif
604}
605' > .tmp_src.cc
606 if test_compile "$LIBZ ${INCZ:+-I$INCZ}" zlib zlib; then
607 if test_execute; then
608 cnf_append "SDK_VBOX_ZLIB_LIBS" "`echo $LIBZ|sed 's+-l++g'`"
609 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
610 fi
611 fi
612}
613
614#
615# Check for libpng, needed by kchmviewer
616#
617function check_png()
618{
619 test_header libpng
620 echo '
621#include <cstdio>
622#include <png.h>
623extern "C" int main(void)
624{
625 printf("found version %s", PNG_LIBPNG_VER_STRING);
626#if PNG_LIBPNG_VER >= 10205
627 printf(", OK.\n");
628 return 0;
629#else
630 printf(", expected version 1.2.5 or higher\n");
631 return 1;
632#endif
633}
634' > .tmp_src.cc
635 if test_compile "$LIBPNG ${INCPNG:+-I$INCPNG}" libpng libpng nofatal; then
636 if test_execute nofatal; then
637 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`echo $LIBPNG|sed 's+-l++g'`"
638 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
639 fi
640 fi
641}
642
643#
644# Check for pam, needed by VRDPAuth
645# Version 79 was introduced in 9/2005, do we support older versions?
646# Debian/sarge uses 76
647# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
648#
649function check_pam()
650{
651 test_header pam
652 echo '
653#include <cstdio>
654#include <security/pam_appl.h>
655extern "C" int main(void)
656{
657 printf("found version %d", __LIBPAM_VERSION);
658 if (__LIBPAM_VERSION >= 76)
659 {
660 printf(", OK.\n");
661 return 0;
662 }
663 else
664 {
665 printf(", expected version 76 or higher\n");
666 return 1;
667 }
668}
669' > .tmp_src.cc
670 if test_compile "-lpam" pam pam nofatal; then
671 if test_execute nofatal; then
672 return 0;
673 fi
674 fi
675 test_header linux_pam
676 echo '
677#include <cstdio>
678#include <security/pam_appl.h>
679extern "C" int main(void)
680{
681 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
682 if (__LINUX_PAM__ >= 1)
683 {
684 printf(", OK.\n");
685 return 0;
686 }
687 else
688 {
689 printf(", expected version 1.0 or higher\n");
690 return 1;
691 }
692}
693' > .tmp_src.cc
694 if test_compile "-lpam" pam pam; then
695 test_execute
696 fi
697}
698
699#
700# Check for the SDL library, needed by VBoxSDL and VirtualBox
701# We depend at least on version 1.2.7
702#
703function check_sdl()
704{
705 test_header SDL
706 echo '
707#include <cstdio>
708#include <SDL/SDL.h>
709#include <SDL/SDL_main.h>
710extern "C" int main(void)
711{
712 printf("found version %d.%d.%d",
713 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
714#if SDL_VERSION_ATLEAST(1,2,7)
715 printf(", OK.\n");
716 return 0;
717#else
718 printf(", expected version 1.2.7 or higher\n");
719 return 1;
720#endif
721}
722' > .tmp_src.cc
723 if test_compile "$LIBSDL $LIBSDLMAIN ${INCSDL:+-I$INCSDL}" SDL SDL; then
724 if test_execute; then
725 cnf_append "LIB_SDK_LIBSDL_SDL" "`echo $LIBSDL|sed 's+-l++g'`"
726 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`echo $LIBSDLMAIN|sed 's+-l++g'`"
727 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
728 fi
729 fi
730}
731
732#
733# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
734#
735function check_sdl_ttf()
736{
737 test_header SDL_ttf
738 echo '
739#include <cstdio>
740#include <SDL/SDL_ttf.h>
741#ifndef SDL_TTF_MAJOR_VERSION
742#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
743#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
744#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
745#endif
746extern "C" int main(void)
747{
748 printf("found version %d.%d.%d",
749 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
750#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
751 printf(", OK.\n");
752 return 0;
753#else
754 printf(", expected version 2.0.6 or higher\n");
755 return 1;
756#endif
757}
758' > .tmp_src.cc
759 if test_compile "-lSDL_ttf" SDL_ttf SDL_ttf; then
760 test_execute
761 fi
762}
763
764#
765# Check for libasound, needed by the ALSA audio backend
766#
767function check_alsa()
768{
769 test_header ALSA
770 echo '
771#include <alsa/asoundlib.h>
772extern "C" int main(void)
773{
774 printf("found version %d.%d.%d",
775 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
776#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
777 printf(", OK.\n");
778 return 0;
779#else
780 printf(", expected version 1.0.6 or higher\n");
781 return 1;
782#endif
783}
784' > .tmp_src.cc
785 if test_compile "-lasound" asound asound; then
786 test_execute
787 fi
788}
789
790#
791# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
792#
793function check_xcursor()
794{
795 test_header Xcursor
796 echo '
797#include <cstdio>
798#include <X11/Xlib.h>
799#include <X11/Xcursor/Xcursor.h>
800extern "C" int main(void)
801{
802 XcursorImage *cursor = XcursorImageCreate (10, 10);
803 XcursorImageDestroy(cursor);
804 return 0;
805}
806' > .tmp_src.cc
807 if test_compile "$LIBX11 $LIBXCURSOR" Xcursor Xcursor; then
808 log_success "found"
809 cnf_append "LIB_XCURSOR" "`echo $LIBXCURSOR|sed 's+-l++g'`"
810 fi
811}
812
813#
814# Check for the X libraries (Xext, X11)
815#
816function check_x()
817{
818 test_header "X libraries"
819 echo '
820#include <cstdio>
821#include <X11/Xlib.h>
822extern "C" int main(void)
823{
824 Display *dpy;
825 int scrn_num;
826 Screen *scrn;
827 Window win;
828
829 dpy = XOpenDisplay(NULL);
830 scrn_num = DefaultScreen(dpy);
831 scrn = ScreenOfDisplay(dpy, scrn_num);
832 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
833 0, 16, InputOutput, CopyFromParent, 0, NULL);
834 XDestroyWindow(dpy, win);
835}
836' > .tmp_src.cc
837 if test_compile "$LIBX11" Xlibs Xlibs; then
838 log_success "found"
839 fi
840}
841
842#
843# Check for the QT library, needed by VirtualBox
844#
845function check_qt()
846{
847 test_header Qt
848 echo '
849#include <cstdio>
850#include <qglobal.h>
851extern "C" int main(void)
852{
853 printf("found version %s", QT_VERSION_STR);
854#if QT_VERSION >= 0x030305
855 printf(", OK.\n");
856 return 0;
857#elif QT_VERSION >= 0x030300
858 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
859#else
860 printf(", expected version 3.3.0 or higher\n");
861 return 1;
862#endif
863}
864' > .tmp_src.cc
865 found_qt=0
866 libs="lib"
867 [ "$LIB" = "lib64" ] && libs="$libs lib64"
868 for q in $QTDIR; do
869 for l in $libs; do
870 echo "compiling the following source file:" >> $LOG
871 cat .tmp_src.cc >> $LOG
872 echo "using the following command line:" >> $LOG
873 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt" >> $LOG
874
875 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt >> $LOG 2>&1
876 if (($?==0)); then
877 if test_execute; then
878 cnf_append "QTDIR" "`cd $q ; pwd`"
879 found_qt=1
880 break
881 fi
882 fi
883 done
884 if (($found_qt==1)); then
885 break
886 fi
887 done
888 if (($found_qt!=1)); then
889 echo -e "\n Qt not found at \"$QTDIR\" or Qt headers not found"
890 echo " Check the file $LOG for detailed error information."
891 fail
892 return 1
893 fi
894 test_header "Qt devtools"
895 if check_avail "$q/bin/moc" QTDIR/bin; then
896 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
897 if (($?!=0)); then
898 log_failure "not found"
899 fail
900 else
901 log_success "found version $moc_ver"
902 fi
903 fi
904}
905
906#
907# Check for Linux sources
908#
909function check_linux()
910{
911 test_header "Linux kernel sources"
912 echo '
913#include <linux/version.h>
914int printf(const char *format, ...);
915int main(void)
916{
917 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
918 (LINUX_VERSION_CODE % 65536) / 256,
919 LINUX_VERSION_CODE % 256);
920#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
921 printf(", OK.\n");
922 return 0;
923#else
924 printf(", expected version 2.4.0 or higher\n");
925 return 1;
926#endif
927}
928' > .tmp_src.c
929 echo "compiling the following source file:" >> $LOG
930 cat .tmp_src.c >> $LOG
931 echo "using the following command line:" >> $LOG
932 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
933 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
934 if (($?!=0)); then
935 echo -e "\n Linux kernel headers not found at $LINUX"
936 echo " Check the file $LOG for detailed error information."
937 fail
938 else
939 if test_execute; then
940 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
941 fi
942 fi
943}
944
945#
946# Check for kchmviewer, needed to display the online help
947#
948function check_kchmviewer()
949{
950 test_header kchmviewer
951 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
952 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
953 if (($?!=0)); then
954 log_failure "not found"
955 fail
956 else
957 log_success "found version $kchmviewer_ver"
958 fi
959 fi
960}
961
962#
963# Check for the kBuild tools, we don't support GNU make
964#
965function check_kbuild()
966{
967 test_header kBuild
968 if check_avail "$KBUILDDIR_BIN/kmk" KBUILDDIR really; then
969 log_success "found"
970 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
971 echo "export BUILD_PLATFORM_ARCH=\"$MACHINE\"" >> $ENV
972 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
973 echo "export BUILD_TARGET_ARCH=\"$MACHINE\"" >> $ENV
974 echo "export BUILD_TARGET_CPU=\"$CPU\"" >> $ENV
975 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
976 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
977 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
978 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
979 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
980 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
981 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
982 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
983 echo "export PATH" >> $ENV
984 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
985 fi
986}
987
988
989#
990# Check for compiler.h
991# Some Linux distributions include "compiler.h" in their libc linux
992# headers package, some don't. Most don't need it, building might (!)
993# not succeed on openSUSE without it.
994#
995# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
996#
997function check_compiler_h
998{
999 test_header compiler.h
1000 if ! test -f "/usr/include/linux/compiler.h"; then
1001 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1002 log_success "compiler.h not found"
1003 else
1004 log_success "compiler.h found"
1005 fi
1006}
1007
1008
1009#
1010# Check for the libhal library for obtaining hardware information on Linux
1011#
1012function check_libhal()
1013{
1014 test_header libhal
1015 pc_cflagshal=`pkg-config hal --cflags 2>/dev/null`
1016 pc_libhal=`pkg-config hal --libs-only-l 2>/dev/null`
1017 pc_libpathhal=`pkg-config hal --libs-only-L 2>/dev/null`
1018 pc_verhal=`pkg-config hal --modversion 2>/dev/null`
1019 if [ ! -z "$pc_cflagshal" ]; then # is this acceptable?
1020 CFLAGSHAL=$pc_cflagshal
1021 LIBPATHHAL=$pc_libpathhal
1022 LIBHAL=$pc_libhal
1023 fi
1024 echo '
1025#include <cstdio>
1026#include <libhal.h>
1027extern "C" int main(void)
1028{
1029 DBusError dbusError;
1030 dbus_error_init (&dbusError);
1031 LibHalContext *halContext = libhal_ctx_new();
1032 if (halContext != 0)
1033 {
1034 libhal_ctx_free(halContext);
1035 }
1036 return 0;
1037}
1038' > .tmp_src.cc
1039 if test_compile "$CFLAGSHAL $LIBPATHHAL $LIBHAL" libhal libhal; then
1040 log_success "found version $pc_verhal"
1041 cnf_append "LIB_HAL_CFLAGS" "$CFLAGSHAL"
1042 cnf_append "LIB_HAL_LIBS" "`echo $LIBHAL | sed 's+-l++g'`"
1043 cnf_append "LIB_HAL_LIBPATH" "`echo $LIBPATHHAL | sed 's+-L++g'`"
1044 cnf_append "VBOX_WITH_LIBHAL" "1"
1045 fi
1046}
1047
1048
1049#
1050# Show help
1051#
1052function show_help()
1053{
1054 cat << EOF
1055Usage: ./configure [OPTIONS]...
1056
1057Configuration:
1058 -h, --help display this help and exit
1059 --nofatal don't abort on errors
1060 --disable-xpcom disable XPCOM and related stuff
1061 --disable-sdl-ttf disable SDL_ttf detection
1062 --build-xalan build xalan & xerces from shipped sources
1063 --without-hal do not use libhal, even if it is available
1064
1065Paths:
1066 --with-gcc=PATH location of the gcc compiler [$CC]
1067 --with-g++=PATH location of the g++ compiler [$CXX]
1068 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1069 --with-iasl=PATH location of the iasl compiler [$IASL]
1070 --with-hal-cflags=FLAGS cflags for libhal [$CFLAGSHAL]
1071 --with-hal=LIB location of the libhal libraries [$LIBHAL]
1072 --with-linux=DIR Linux kernel source directory [$LINUX]
1073 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1074 --with-qt-dir=DIR directory for QT headers/libraries [$QTDIR]
1075 --with-xalan=LIB location of the xalan library [$LIBXALAN]
1076 --with-xerces=LIB location of the xerces library [$LIBXERCES]
1077
1078Build type:
1079 -d, --build-debug build with debugging symbols and assertions
1080EOF
1081 exit 0
1082}
1083
1084
1085#
1086# The body.
1087#
1088
1089# scan command line options
1090for option; do
1091 case "$option" in
1092 --help|-help|-h)
1093 show_help
1094 ;;
1095 --nofatal)
1096 nofatal=1
1097 ;;
1098 --with-gcc=*)
1099 CC=`echo $option | cut -d'=' -f2`
1100 ;;
1101 --with-g++=*)
1102 CXX=`echo $option | cut -d'=' -f2`
1103 ;;
1104 --with-kbuild=*)
1105 KBUILDDIR=`echo $option | cut -d'=' -f2`
1106 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1107 echo "Error: KBUILDDIR contains invalid characters!"
1108 exit 1
1109 fi
1110 ;;
1111 --with-qt-dir=*)
1112 QTDIR=`echo $option | cut -d'=' -f2`
1113 ;;
1114 --with-hal-dir=*)
1115 INCHAL=`echo $option | cut -d'=' -f2`
1116 ;;
1117 --with-hal=*)
1118 LIBHAL=`echo $option | cut -d'=' -f2`
1119 ;;
1120 --with-iasl=*)
1121 IASL=`echo $option | cut -d'=' -f2`
1122 ;;
1123 --with-linux=*)
1124 LINUX=`echo $option | cut -d'=' -f2`
1125 ;;
1126 --with-mkisofs=*)
1127 MKISOFS=`echo $option | cut -d'=' -f2`
1128 ;;
1129 --with-xalan=*)
1130 LIBXALAN=`echo $option | cut -d'=' -f2`
1131 ;;
1132 --with-xerces=*)
1133 LIBXERCES=`echo $option | cut -d'=' -f2`
1134 ;;
1135 --disable-xpcom)
1136 WITH_XPCOM=0
1137 ;;
1138 --disable-sdl-ttf)
1139 WITH_SDL_TTF=0
1140 ;;
1141 --disable-qt)
1142 WITH_QT=0
1143 ;;
1144 --without-hal)
1145 WITH_HAL=0
1146 ;;
1147 --build-debug|-d)
1148 BUILD_TYPE=debug
1149 ;;
1150 --build-xalan)
1151 LIBXERCES=``
1152 LIBXALAN=``
1153 ;;
1154 --ose)
1155 OSE=2
1156 ;;
1157 --odir=*)
1158 ODIR=`echo $option | cut -d'=' -f2`
1159 ;;
1160 *)
1161 echo
1162 echo "Unrecognized option \"$option\""
1163 echo
1164 show_help
1165 ;;
1166 esac
1167done
1168
1169LOG="${ODIR:+$ODIR/}$LOG"
1170ENV="${ODIR:+$ODIR/}$ENV"
1171CNF="${ODIR:+$ODIR/}$CNF"
1172
1173# initialize output files
1174cat > $LOG << EOF
1175# Log file generated by
1176#
1177# '$0 $*'
1178#
1179
1180EOF
1181cat > $CNF << EOF
1182# -*- Makefile -*-
1183#
1184# automatically generated by
1185#
1186# '$0 $*'
1187#
1188# It will be completely overwritten if configure is executed again.
1189#
1190
1191EOF
1192cat > $ENV << EOF
1193#!/bin/bash
1194#
1195# automatically generated by
1196#
1197# '$0 $*'
1198#
1199# It will be completely overwritten if configure is executed again.
1200# Make sure you source this file once before you start to build VBox.
1201#
1202
1203EOF
1204
1205# test if we are OSE
1206if (($OSE==1)) && [ -d "`cd $(dirname $0); pwd`/src/VBox/Devices/USB" ]; then
1207 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1208 echo >> $LOG
1209 OSE=0
1210fi
1211
1212# first determine our environment
1213check_environment
1214check_kbuild
1215
1216# some things are not available in for OSE
1217if (($OSE)); then
1218 cnf_append "VBOX_OSE" "1"
1219 cnf_append "VBOX_WITH_TESTSUITE" ""
1220 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
1221
1222 if [ "$OS" = "linux" ]; then
1223 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
1224 else
1225 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
1226 fi
1227 echo >> $CNF
1228fi
1229
1230# emit disable directives corresponding to any --disable-xxx options.
1231(($WITH_XPCOM==0)) && cnf_append "VBOX_WITH_MAIN" ""
1232(($WITH_QT==0)) && cnf_append "VBOX_WITH_QTGUI" ""
1233(($WITH_SDL_TTF==0)) && cnf_append "VBOX_WITH_SECURELABEL" ""
1234
1235# append the tools directory to the default search path
1236echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1237
1238# append some extra paths
1239PATH="$PATH:/opt/gnome/bin"
1240
1241# the tools
1242check_gcc
1243[ "$OS" != "darwin" ] && check_as86
1244[ "$OS" != "darwin" ] && check_bcc
1245[ "$OS" != "darwin" ] && check_iasl
1246# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
1247# [ "$OS" != "darwin" ] && check_yasm
1248[ "$OS" != "darwin" ] && check_xsltproc
1249(($OSE==0)) && check_mkisofs
1250
1251# the libraries
1252[ "$OS" != "darwin" ] && check_pthread
1253(($WITH_XPCOM==1)) && check_xalan
1254(($WITH_XPCOM==1)) && check_xerces
1255(($WITH_LIBIDL==1)) && check_libidl
1256(($OSE==0)) && check_ssl
1257[ "$OS" != "darwin" ] && check_z
1258(($OSE==0)) && check_png
1259(($OSE==0)) && [ "$OS" = "linux" ] && check_pam
1260[ "$OS" != "darwin" ] && check_sdl
1261(($WITH_SDL_TTF==1)) && (($OSE==0)) && check_sdl_ttf
1262[ "$OS" != "darwin" ] && check_alsa
1263[ "$OS" != "darwin" ] && check_x
1264[ "$OS" != "darwin" ] && check_xcursor
1265(($WITH_QT==1)) && check_qt
1266
1267# Linux-specific
1268[ "$OS" = "linux" ] && check_linux
1269[ "$OS" = "linux" ] && check_compiler_h
1270[ "$OS" = "linux" -a "$WITH_HAL" = "1" ] && check_libhal
1271
1272# success!
1273echo
1274echo "Successfully generated '$CNF' and '$ENV'."
1275echo "Source '$ENV' once before you start to build VBox:"
1276echo ""
1277echo " source $ENV"
1278echo " kmk"
1279echo ""
1280if [ "$OS" = "linux" ]; then
1281 echo "To compile the kernel module, do:"
1282 echo ""
1283 echo " cd ./out/$OS.$MACHINE/$BUILD_TYPE/bin/src"
1284 echo " make"
1285 echo ""
1286fi
1287echo "Enjoy!"
1288cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use